local RockSaltMine = ...

-- Register common prefab nodes
RockSaltMine:registerAssetId("models/rocksaltmine.fbx/Prefab/rocksaltminePart", "ROCK_SALT_MINE_PREFAB")

RockSaltMine:register({
--Déclare que l'objet que l'on crée appartient à la class BUILDING
	DataType = "BUILDING",
--Déclare la classe de l'objet que l'on crée
	Id = "ROCK_SALT_MINE",
--Déclaration du Nom  Sert dans l'ecran de selection du Mod
	Name = "ROCK_SALT_MINE_NAME",
--Renseigne le champ description de l'objet sert a classer l'objet dans les menus
	Description = "ROCK_SALT_MINE_DESC",
--Renseigne le champ Building Type. cela va permettre de classer l'objet dans les menus
	BuildingType = "GENERAL",
--renseigne le champ BuildingPartList de l'objet que l'on crée un peu plus loin	
	BuildingPartSetList = {
		{
			Name = "ROCK_SALT_MINE_NAME",
                	BuildingPartList = { "ROCK_SALT_MINE_PART" }
                }
        } 
--Renseigne le champ Nombre de villageois requis pour la construction. Ici inactivé pour le test
	--VillagerRequired = { Status = "NEWCOMER", Quantity = 8 }
})


-- Register the princess tower part
RockSaltMine:register({
	DataType = "BUILDING_PART",
	Id = "ROCK_SALT_MINE_PART",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "ROCK_SALT_MINE_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 5 },
			{ Resource = "TOOL", Quantity = 2 }
		}
	},
	AssetBuildingFunction = "ROCK_SALT_MINE_FUNCTION"
})
RockSaltMine:register({
		DataType = "BUILDING_FUNCTION_WORKPLACE",
                Id = "ROCK_SALT_MINE_FUNCTION",
		WorkerCapacity = 3,
                RelatedJob = { Job = "MINER", Behavior = "WORK_BEHAVIOR" },
                InputInventoryCapacity = {
			{ Resource = "WATER", Quantity = 50 }
                },
                ResourceListNeeded = {
                	{ Resource = "WATER", Quantity = 2 }
                },
                ResourceProduced = {
			{ Resource = "BRINE", Quantity = 1 }
                }
})

RockSaltMine:registerPrefabComponent("models/rocksaltmine.fbx/Prefab/rocksaltminePart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = {6, 4}
})

-- Override building part components properties (generated by the building asset processor) to add building zones

RockSaltMine:registerPrefabComponent("models/rocksaltmine.fbx/Prefab/rocksaltminePart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 6, 4 }
})
