local SaltMarshes = ...

-- Register common prefab nodes
SaltMarshes:registerAssetId("models/saltmarshes.fbx/Prefab/saltmarshesPart", "SALT_MARSHES_PREFAB")

SaltMarshes:register({
--Déclare que l'objet que l'on crée appartient à la class BUILDING
	DataType = "BUILDING",
--Déclare la classe de l'objet que l'on crée
	Id = "SALT_MARSHES",
--Déclaration du Nom  Sert dans l'ecran de selection du Mod
	Name = "SALT_MARSHES_NAME",
--Renseigne le champ description de l'objet sert a classer l'objet dans les menus
	Description = "SALT_MARSHES_DESC",
--Renseigne le champ Building Type. cela va permettre de classer l'objet dans les menus
	BuildingType = "GENERAL",
--renseigne le champ BuildingPartList de l'objet que l'on crée un peu plus loin	
	BuildingPartSetList = {
		{
			Name = "SALT_MARSHES_NAME",
                	BuildingPartList = { "SALT_MARSHES_PART" }
                }
        } 
--Renseigne le champ Nombre de villageois requis pour la construction. Ici inactivé pour le test
	--VillagerRequired = { Status = "NEWCOMER", Quantity = 8 }
})


-- Register the princess tower part
SaltMarshes:register({
	DataType = "BUILDING_PART",
	Id = "SALT_MARSHES_PART",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "SALT_MARSHES_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 1 }
		}
	},
	AssetBuildingFunction = "SALT_MARSHES_FUNCTION"
})
SaltMarshes:register({
		DataType = "BUILDING_FUNCTION_WORKPLACE",
                Id = "SALT_MARSHES_FUNCTION",
		WorkerCapacity = 1,
                RelatedJob = { Job = "SALT_WORKER", Behavior = "WORK_BEHAVIOR" },
                ResourceProduced = {
			{ Resource = "SALT2", Quantity = 1 }
                }
})

SaltMarshes:registerPrefabComponent("models/saltmarshes.fbx/Prefab/saltmarshesPart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = {10, 2}
})

-- Override building part components properties (generated by the building asset processor) to add building zones

SaltMarshes:registerPrefabComponent("models/saltmarshes.fbx/Prefab/saltmarshesPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 4, 4 }
})

-- Register grounding components

SaltMarshes:registerPrefabComponent("models/saltmarshes.fbx/Prefab/saltmarshesPart/marais1", {
	DataType = "COMP_GROUNDED"
})
SaltMarshes:registerPrefabComponent("models/saltmarshes.fbx/Prefab/saltmarshesPart/cabane", {
	DataType = "COMP_GROUNDED"
})
SaltMarshes:registerPrefabComponent("models/saltmarshes.fbx/Prefab/saltmarshesPart/fleur", {
	DataType = "COMP_GROUNDED"
})
SaltMarshes:registerPrefabComponent("models/saltmarshes.fbx/Prefab/saltmarshesPart/grosSel1", {
	DataType = "COMP_GROUNDED"
})
SaltMarshes:registerPrefabComponent("models/saltmarshes.fbx/Prefab/saltmarshesPart/grosSel2", {
	DataType = "COMP_GROUNDED"
})

-- Register air vent particle system (rope)

SaltMarshes:registerAssetId("models/saltmarshes.fbx/Prefab/saltmarshesPart/marais1/WaterEmitter1", "SALT_MARSHES_WATER_EMITTER_PREFAB")
--SaltMarshes:registerAssetId("models/saltmarshes.fbx/Prefab/saltmarshesPart/marais1/SaltEmitter1", "SALT_MARSHES_SALT_EMITTER_PREFAB")

SaltMarshes:registerPrefabComponent("models/saltmarshes.fbx/Prefab/saltmarshesPart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
                 { "SALT_MARSHES_WATER_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }--,
--                 { "SALT_MARSHES_SALT_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
	}
})

SaltMarshes:registerPrefabComponent("models/saltmarshes.fbx/Prefab/saltmarshesPart/marais1/WaterEmitter1", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "SALT_MARSHES_WATER_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = false
})

SaltMarshes:registerPrefabComponent("models/saltmarshes.fbx/Prefab/saltmarshesPart/marais1/WaterEmitter1", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})

--SaltMarshes:registerPrefabComponent("models/saltmarshes.fbx/Prefab/saltmarshesPart/marais1/SaltEmitter1", {
--	DataType = "COMP_PARTICLE_EMITTER",
--	ParticleSystem = "SALT_MARSHES_SALT_PARTICLE_SYSTEM",
--	IsPlaying = true,
--	IsEmitting = false
--})

--SaltMarshes:registerPrefabComponent("models/saltmarshes.fbx/Prefab/saltmarshesPart/marais1/SaltEmitter1", {
--	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
--	Enabled = false
--})
